<?php

namespace App\Http\Controllers;

use App\Models\Device;
use App\Models\OwnerTransaction;
use Illuminate\Http\Request;

class OwnerTransactionController extends Controller
{
    public function create(Device $device)
    {
        return view('owners.create', ['device' => $device]);
    }

    public function store(Device $device, Request $request)
    {
        $formFields = $request->validate([
            'rz_username' => 'required',
            'timestamp_owner_since' => 'required'
        ]);

        $formFields['device_id'] = $device->device_id;
        OwnerTransaction::create($formFields);

        return redirect('/');
    }

    public function edit(OwnerTransaction $owner)
    {
        return view('owners.edit', ['owner' => $owner]);
    }

    public function update(OwnerTransaction $owner, Request $request)
    {
        $formFields = $request->validate([
            'rz_username' => 'required',
            'timestamp_owner_since' => 'required'
        ]);

        $owner->update($formFields);

        return redirect('/');
    }

    public function destroy(OwnerTransaction $owner)
    {
        $owner->delete();
        return back();
    }
}
